## ros-lunar-sick-scan 0.0.16

=== CMakeLists.txt ===
####################################################
# CMakeLists.txt for project sick_scan
#
#
####################################################
cmake_minimum_required(VERSION 2.8.3)


macro(use_cxx11)
	if (CMAKE_VERSION VERSION_LESS "3.1")
		if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
			set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
		endif ()
	else ()
		set (CMAKE_CXX_STANDARD 11)
	endif ()
endmacro(use_cxx11)

# set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++03")

# Switch on, if you use c11-specific commands
# use_cxx11()

# set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
# set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpedantic")

project(sick_scan)

# By uncommenting the following lines you can list all variable names ...
# --- CUT ---
# get_cmake_property(_variableNames VARIABLES)
# list (SORT _variableNames)
# foreach (_variableName ${_variableNames})
#	message(STATUS "${_variableName}=${${_variableName}}")
# endforeach()
# --- CUT ---

# For warning <catkin_workspace>/devel/include' should be placed in
# the devel space instead of the build space
# see: https://answers.ros.org/question/67244/qtcreator-with-catkin/



# message(${CMAKE_BINARY_DIR})

# set(CATKIN_DEVEL_PREFIX "${CMAKE_BINARY_DIR}/devel")
# set(CMAKE_PREFIX_PATH "${CMAKE_BINARY_DIR}/devel;/opt/ros/melodic")


find_package(catkin REQUIRED
    COMPONENTS
      roscpp
      sensor_msgs
      diagnostic_updater
      dynamic_reconfigure
      geometry_msgs
      std_msgs
      sensor_msgs
      visualization_msgs
      message_generation
      pcl_conversions
      pcl_ros
)


find_package(PkgConfig REQUIRED)

find_package(Boost REQUIRED COMPONENTS system)

generate_dynamic_reconfigure_options(
		cfg/SickScan.cfg
		cfg/tf_dyn.cfg
)

add_message_files(

		FILES
		SickImu.msg
		RadarObject.msg
		RadarPreHeaderDeviceBlock.msg
		RadarPreHeaderMeasurementParam1Block.msg
		RadarPreHeaderStatusBlock.msg
		RadarPreHeaderEncoderBlock.msg
		RadarPreHeader.msg
		RadarScan.msg
)

generate_messages(
        DEPENDENCIES
        std_msgs
        geometry_msgs
        sensor_msgs
)

catkin_package(
        DEPENDS Boost
        CATKIN_DEPENDS message_runtime roscpp sensor_msgs diagnostic_updater dynamic_reconfigure
        LIBRARIES sick_scan_lib
        INCLUDE_DIRS include )

include_directories(include include/tinyxml ${catkin_INCLUDE_DIRS} include/sick_scan)

add_library(sick_scan_lib
    driver/src/sick_scan_common.cpp
    driver/src/abstract_parser.cpp
	driver/src/tcp/tcp.cpp
	driver/src/tcp/Mutex.cpp
	driver/src/tcp/SickThread.cpp
    driver/src/tcp/errorhandler.cpp
    driver/src/tcp/toolbox.cpp
    driver/src/tcp/Time.cpp
    driver/src/tcp/colaa.cpp
    driver/src/tcp/colab.cpp
	driver/src/binScanf.cpp
	driver/src/sick_scan_common_tcp.cpp
	driver/src/sick_generic_radar.cpp
	driver/src/sick_generic_imu.cpp
	driver/src/sick_generic_parser.cpp
	driver/src/sick_scan_common_nw.cpp
		include/sick_scan/sick_scan_config.h
		driver/src/sick_scan_config.cpp
		include/sick_scan/softwarePLL.h
		driver/src/softwarePLL.cpp
		)

add_dependencies(sick_scan_lib ${PROJECT_NAME}_gencfg ${catkin_EXPORTED_TARGETS} ${${PROJECT_NAME}_EXPORTED_TARGETS})

target_link_libraries(sick_scan_lib
    ${catkin_LIBRARIES})

add_executable(sick_generic_caller
    driver/src/sick_generic_laser.cpp
    driver/src/sick_generic_caller.cpp
	)

#
#  radar_object_marker (receives radar msg. and publishes marker array for rviz or similar
#
add_executable(radar_object_marker
        tools/radar_object_marker/src/radar_object_marker.cpp
		tools/pcl_converter/src/gnuplotPaletteReader.cpp
        include/radar_object_marker/radar_object_marker.h)
target_link_libraries(radar_object_marker sick_scan_lib)
#
#
#



add_executable(pcl_converter tools/pcl_converter/src/pcl_converter.cpp tools/pcl_converter/src/gnuplotPaletteReader.cpp)

target_link_libraries(pcl_converter
        ${catkin_LIBRARIES}
        ${roslib_LIBRARIES}
        ${PCL_LIBRARIES})


# add_executable( pcl_find_plane tools/pcl_converter/src/pcl_find_plane.cpp)
# target_link_libraries(pcl_find_plane ${catkin_LIBRARIES})


target_link_libraries(sick_generic_caller sick_scan_lib)

add_executable(sick_scan_test
	test/src/sick_scan_test.cpp
	driver/src/tinyxml/tinystr.cpp
	driver/src/tinyxml/tinyxml.cpp
	driver/src/tinyxml/tinyxmlerror.cpp
	driver/src/tinyxml/tinyxmlparser.cpp
	)
target_link_libraries(sick_scan_test
        ${catkin_LIBRARIES}
        ${roslib_LIBRARIES}
        sick_scan_lib)

#
#  Sensor alignment tool
#
#  currently disabled for trusty support
# add_executable(sensor_alignment
#		tools/sensor_alignment/sensor_alignment_tf_dyn.cpp
#		)
#
# target_link_libraries(sensor_alignment
#		${catkin_LIBRARIES}
#		)
# add_dependencies(sensor_alignment ${PROJECT_NAME}_gencfg)

# target_link_libraries(${PROJECT_NAME}_pointcloud2_refresh
#		${catkin_LIBRARIES}
#	)


# Destinations:
# LIB for library
# BIN for Binaries
# INCLUDE for Includes
# SHARE for config files, launch files etc.


install(TARGETS sick_scan_lib
    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(
    TARGETS
        sick_generic_caller
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(
		TARGETS
		sick_scan_test
		RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})


install(FILES include/${PROJECT_NAME}/abstract_parser.h
              include/${PROJECT_NAME}/sick_scan_common.h
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(DIRECTORY test/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/test 
	FILES_MATCHING PATTERN "*.xml"
	PATTERN "test/src" EXCLUDE)

install(DIRECTORY launch/
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch)

install(DIRECTORY meshes/
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/meshes)

install(DIRECTORY urdf/
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/urdf)

=== debian/changelog ===
ros-lunar-sick-scan (0.0.16-0stretch) stretch; urgency=high

  * Update README.md
  * Improved performance

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 13 Feb 2019 23:00:00 -0000

ros-lunar-sick-scan (0.0.15-0stretch) stretch; urgency=high

  * Update README.md
  * Support for Ubuntu Trusty #001 <https://github.com/SICKAG/sick_scan/issues/001>
  * ip v4 parsing changed due to support of older linux version
  * Contributors: Michael Lehning, Unknown

 -- Michael Lehning <michael.lehning@lehning.de>  Mon, 04 Feb 2019 23:00:00 -0000

ros-lunar-sick-scan (0.0.14-0stretch) stretch; urgency=high

  * Merge branch 'devel'
  * ip address setting support, improved Debug MSG
  * Updated MRS6xxx launchfile
  * getting diagrams otimized for MRS6124
  * Warning option as comment added
  * compilation fixes for uninitialized variables and no return functions
  * writing ip address to eeprom prepared
  * improved imu support
  * added Python script to detect scanners
  * Added first implementation of imu support
  * IMU message handling prepared
  * added Ip arg name
  * Updated meshes
  * Sample file for launching and rviz-config files
  * Added lms1 and lms5 meshes and urdfs for them.  The gazebo sensors might still need work
  * Lookup Table for multi echo fixed
  * Test tool integrated into CMakeLists.txt
  * Build receipt for sensor_alighment
  * Fix for startup procedure to enable automatic  SOPAS ascii to SOPAS bin.
  * stopScanData introduced, init flag introduced, signal handler introduced
    change start process to state machine
  * radar_object_marker launch file updated
  * Radar Simulation optimized
  * Parsing of  PreHeader fixed and simulation optimized
    Raw target added for simulatoin
  * RMS3xx documentation
  * Preheading Parsing optimized
  * Radar preheader parsing extended
  * Radar datagram explanation
  * Only first echo for MRS6124 as default to reduct data volume
  * radar visualization optimized
  * marker optimized
  * clean of of radar_object_marker
  * support hector slam
  * SLAM-Support documentation
  * hector slam support
  * initial radar documentation added
  * cleanup test program
  * test launch file added to show pointcloud2 AND scans for the MRS1xxx
  * timestamp of radar msg. improved, pointcloud2 debug messages for raw target and object targets added
  * launch file for rosbag testing added
  * Launch file for combination of laser scanner and radar added
  * PCL converter ignores missing intensity values
  * point cloud2image filter added, timestamping optimized
  * Device Identiier handling opimized for MRS1xxx and LMS1xxx
  * test files added
  * omitting of laserscan frameid fixed
  * debug messages removed from test script
  * generation of test launch file without starting the test can be controlled by
    using setting flag entry launch_only to true.
  * Switching of radar properties improved
  * Tracking method and output selection for radar
  * Test application for using min/max-interval checking
    and added more test parameter
  * support for rms3xx prepared
  * Copyright added
  * licensed under apache 2.0
  * file based simulation based on file name pattern added and evaluated.
  * patches for ubuntu
  * pointcloud2 prepared
  * Parsing and test driven development optimized
  * Simulation for objects added
  * support of radar simulation
  * Contributors: Dave Niewinski, Michael Lehning, Sai Kishor Kothakota, Unknown, unknown

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 30 Jan 2019 23:00:00 -0000

ros-lunar-sick-scan (0.0.13-0stretch) stretch; urgency=high

  * moved some cpp files to ensure Debian compatibility
  * Contributors: Unknown

 -- Michael Lehning <michael.lehning@lehning.de>  Tue, 01 May 2018 22:00:00 -0000

ros-lunar-sick-scan (0.0.12-0stretch) stretch; urgency=high

  * Added script to start all test sequentially
  * Added RSSi and Range Deviation Test to sick_scan_test
  * channel handling for 8 bit rssi values corrected
  * Defines for param keyword introduced
  * added ros param for rssi data size 16 or 8 Bit
  * added rssi resolution configswitch
  * support for LMS_5xx and LMS_1xx added
  * testprogramm can now handle comments;
  * Test instructions added
  * Generation of result file
  * inital test revisited
  * Initial version protocol tester
  * Tiny XML Parser added
  * added Sopas protocol param
  * Added Tools and driver folder, removed unnecessary libusb dep.
  * Added scanner_type to parameter set to allow the processing of parallel scanners
  * timeout handling improved
  * reading thread times after connection lost
    Timeout settings optimized
  * protocol switching supported
  * Protocol switching implemented
  * added timeout and binary/ascii detection
  * Support of LMS1104 debugged, skipping scan mgs. publish for MRS6124 (only pointcloud)
  * Adding MRS6124 link to supported scanner table
    Edited trouble shooting
  * Add documentation for network stack
  * scandataCfg for binary commands prepared
  * min_ang, max_ang adapted for MRS6xxx
  * LMS1000 support continue, Bug fix for parsing distance value MRS6xxx, mrs6xxx.launch modified
  * COLA_A and COLA_B prepared
  * Package handling optimized (for asynchron tcp data transfer)
  * Debug info added for receiving tcp packets
  * Support of MRS1104
  * Cleanup and supporting Tim571
  * errorhandler added
  * First version with 9413 bytes packet
  * tcp handling optimized
  * Queue introduced
  * colaa+colab libs included
  * Parsing of MRS6xxx-data packages integrated
  * Timeout incremented due to startup wait phase for MRS6xxx
  * Sleep duration between inital commands changed from 2.0 to 0.2
    Sleep of 10 Sec. introducted after start scandata to ensure that the scanner comes up.

 -- Michael Lehning <michael.lehning@lehning.de>  Tue, 24 Apr 2018 22:00:00 -0000

ros-lunar-sick-scan (0.0.11-0stretch) stretch; urgency=high



 -- Michael Lehning <michael.lehning@lehning.de>  Tue, 23 Jan 2018 23:00:00 -0000

=== debian/control ===
Source: ros-lunar-sick-scan
Section: misc
Priority: extra
Maintainer: Michael Lehning <michael.lehning@lehning.de>
Build-Depends: debhelper (>= 9.0.0), ros-lunar-catkin, ros-lunar-diagnostic-updater, ros-lunar-dynamic-reconfigure, ros-lunar-message-generation, ros-lunar-pcl-conversions, ros-lunar-pcl-ros, ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-visualization-msgs
Homepage: http://wiki.ros.org/sick_scan
Standards-Version: 3.9.2

Package: ros-lunar-sick-scan
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-lunar-diagnostic-updater, ros-lunar-dynamic-reconfigure, ros-lunar-message-runtime, ros-lunar-pcl-conversions, ros-lunar-pcl-ros, ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-visualization-msgs
Description: A ROS driver for the SICK TiM and SICK MRS series of laser scanners.
 This package is based on the original sick_tim-repository of Martin Günther et al.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-sick-scan//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
